package figure;

//--------------------------------------------------------------------//
/**
 * s̒ۃX[p[NX
 */
public abstract class AbstractMatrix implements Matrix{

/** vZ̎臒l */
  protected static final double TOLERANCE=1.0E-20;

/** ̐Βl̍ől */
  public double dataMax;

  protected AbstractMatrix(){
    dataMax=0.0;
  }

//--------------------------------------------------------------------//
/**
 * s񂪑Ώ̂ǂ𔻕ʂ
 * @return s񂪑Ώ̂łꍇ true
 */
  public boolean isSymmetry(){
    if(rowCount()!=columnCount()) return false;
    int size=rowCount();
    for(int i=0;i<size-1;i++){
      for(int j=i+1;j<size;j++){
      	if(get(i,j)!=get(j,i)) return false;
      }
    }
    return true;
  }

//--------------------------------------------------------------------//
/**
 * g[XԂ
 * @return g[X
 */
  public double trace(){
    if(rowCount()!=columnCount()) return 0.0;
    double tr=0.0;
    int rowCount=rowCount();
    for(int i=0;i<rowCount;i++) tr+=get(i,i);
    return tr;
  }

//--------------------------------------------------------------------//
/**
 * s񎮂Ԃ
 * @return s
 */
  public double determinant(){
    if(rowCount()!=columnCount()) return 0.0;
    int rowCount=rowCount();
    switch(rowCount){
      case 1:
      	return get(0,0);
      case 2:
      	return get(0,0)*get(1,1)-get(0,1)*get(1,0);
      default:
      	double det=0.0;
      	int isw=1;
      	for(int i=0;i<rowCount;i++){
      	  det+=isw*get(0,i)*eliminateRowColumn(0,i).determinant();
      	  isw*=-1;
      	}
      	return det;
    }
  }

//--------------------------------------------------------------------//
/**
 * sxNgԂ
 * @param row s̃CfbNX
 * @return w肵s̃xNg
 */
  public Vector getRowVector(int row){
    int columnCount=columnCount();
    Vector v=new Vector(columnCount);
    for(int j=0;j<columnCount;j++){
      v.set(j,get(row,j));
    }
    return v;
  }

//--------------------------------------------------------------------//
/**
 * xNgԂ
 * @param column ̃CfbNX
 * @return w肵̃xNg
 */
  public Vector getColumnVector(int column){
    int rowCount=rowCount();
    Vector v=new Vector(rowCount);
    for(int i=0;i<rowCount;i++){
      v.set(i,get(i,column));
    }
    return v;
  }

//--------------------------------------------------------------------//
/**
 * sxNgԂ
 * @return sxNgi[z
 */
  public Vector[] getRowVectors(){
    int rowCount=rowCount();
    int columnCount=columnCount();
    Vector v[]=new Vector[rowCount];
    for(int i=0;i<rowCount;i++){
      v[i]=new Vector(columnCount);
      for(int j=0;j<columnCount;j++){
      	v[i].set(j,get(i,j));
      }
    }
    return v;
  }

//--------------------------------------------------------------------//
/**
 * xNgԂ
 * @return xNgi[z
 */
  public Vector[] getColumnVectors(){
    int rowCount=rowCount();
    int columnCount=columnCount();
    Vector v[]=new Vector[columnCount];
    for(int j=0;j<columnCount;j++){
      v[j]=new Vector(rowCount);
      for(int i=0;i<rowCount;i++){
      	v[j].set(i,get(i,j));
      }
    }
    return v;
  }

//--------------------------------------------------------------------//
/**
 * f[^͈͂mF
 * @param row s̃CfbNX
 * @param column ̃CfbNX
 */
  protected void checkRange(int row,int column){
    if((row<0) || (rowCount()<=row)
    || (column<0) || (columnCount()<=column)){
      throw new IndexOutOfBoundsException();
    }
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̃Rs[Ԃ
 * @return ̃CX^X̕
 */
  public Object clone(){
    try{
      return super.clone();
    }
    catch(CloneNotSupportedException ex){
      throw new InternalError();
    }
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̃nbVR[hlԂ
 * @return IuWFNg̃nbVR[hl
 */
  public int hashCode(){
    int rowCount=rowCount();
    int columnCount=columnCount();
    int bit=31*rowCount+columnCount;
    for(int i=0;i<columnCount;i++){
      for(int j=0;j<columnCount;j++){
      	long l=Double.doubleToLongBits(get(i,j));
      	bit=31*bit+(int)(l^(l>>>32));
      }
    }
    return bit;
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̓
 * @param obj rΏۂ̃IuWFNg
 * @return rΏۂ̃IuWFNg <code>Matrix</code>
 *         ̃CX^Xœlꍇ true
 */
  public boolean equals(Object obj){
    if(obj instanceof Matrix){
      Matrix m=(Matrix)obj;
      int rowCount=rowCount();
      int columnCount=columnCount();
      if((rowCount==m.rowCount()) && (columnCount==m.columnCount())){
      	for(int i=0;i<rowCount;i++){
      	  for(int j=0;j<columnCount;j++){
      	    if(get(i,j)!=m.get(i,j)) return false;
      	  }
      	}
      	return true;
      }
    }
    return false;
  }

//--------------------------------------------------------------------//
/**
 * f[^i[zԂ
 * @return ̃IuWFNg̕\i[z
 */
  public String[] toStrings(){
    int rowCount=rowCount();
    int columnCount=columnCount();
    String strings[]=new String[rowCount];
    for(int i=0;i<rowCount;i++){
      StringBuilder sb=new StringBuilder();
      for(int j=0;j<columnCount;j++){
      	sb.append('\t');
      	sb.append(get(i,j));
      }
      strings[i]=sb.toString();
    }
    return strings;
  }

//--------------------------------------------------------------------//
/**
 * f[^Ԃ
 * @return ̃IuWFNg̕\
 */
  public String toString(){
    StringBuilder sb=new StringBuilder();
    String strings[]=toStrings();
    for(int i=0;i<strings.length;i++){
      sb.append(strings[i]);
      sb.append('\n');
      strings[i]=null;
    }
    return sb.toString();
  }
}
