package mbd;
import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Font;
import java.net.URL;
import mbd.component.MBDActionManager;
import mbd.component.MBDViewCanvas;
import mbd.io.MultiBodyModelReader;
import resourcemanager.WordMap;

//--------------------------------------------------------------------//
/**
 * }`{fB_Ci~NXAvbg CNX
 * @author aG
 * @version 1.0
 */
public class MBDApplet extends Applet{

/** G[bZ[W */
  protected String message;

//--------------------------------------------------------------------//
/**
 * Avbg
 */
  public void init(){
    try{
      WordMap.read();
    }
    catch(Exception ex){
      message=String.valueOf(ex);
    }
    double waitTime=getTagNumber("waitTime");
    if(waitTime==Double.NaN) waitTime=10.0;
    Color bgColor=getTagColor("backgroundColor");
    Color fgColor=getTagColor("foregroundColor");
    MultiBodyModel model=getDataModel();
    MBDViewCanvas canvas=new MBDViewCanvas
      (model,message,getTagFont(),bgColor,fgColor);
    MBDActionManager
      manager=new MBDActionManager(canvas,(long)waitTime);
    setLayout(new BorderLayout());
    add(canvas,BorderLayout.CENTER);
    add(manager.getControlPanel(),BorderLayout.SOUTH);
  }

//--------------------------------------------------------------------//
/**
 * \[Xj
 */
  public void destroy(){
    removeAll();
  }

//--------------------------------------------------------------------//
/**
 * HTML^OŎw肳ꂽ̌nf[^fԂ
 * @return HTML^OŎw肳ꂽ̌nf[^f
 */
  public MultiBodyModel getDataModel(){
    String dataName=getParameter("data");
    if(dataName==null) dataName="top.model";
    message=null;
    try{
      Thread.currentThread().setPriority(Thread.MIN_PRIORITY);
    }
    catch(SecurityException ex){
      message=String.valueOf(ex);
      return null;
    }
    MultiBodyModel model=new MultiBodyModel();
    try{
      MultiBodyModelReader reader=new MultiBodyModelReader(model);
      reader.read(new URL(getDocumentBase(),dataName));
      return model;
    }
    catch(Exception ex){
      message=String.valueOf(ex);
      ex.printStackTrace();
      return null;
    }
  }

//--------------------------------------------------------------------//
/**
 * HTML^OŎw肳ꂽFԂ
 * @param name p[^
 * @return HTML^OŎw肳ꂽF
 */
  protected Color getTagColor(String name){
    String value=getParameter(name);
    if(value==null) return null;
    try{
      return new Color(Integer.parseInt(value,16));
    }
    catch(NumberFormatException ex){
      return null;
    }
  }

//--------------------------------------------------------------------//
/**
 * HTML^OŎw肳ꂽtHgԂ
 * @return HTML^OŎw肳ꂽtHg
 */
  protected Font getTagFont(){
    String fontName=getParameter("fontName");
    if(fontName==null) fontName="Serif";

    String s=getParameter("fontStyle");
    int fontStyle=Font.PLAIN;
    if(s!=null){
      if(s.equals("bold")){
      	fontStyle=Font.BOLD;
      }
      else if(s.equals("italic")){
      	fontStyle=Font.ITALIC;
      }
    }

    s=getParameter("fontSize");
    int fontSize=14;
    try{
      fontSize=Integer.parseInt(s);
    }
    catch(NumberFormatException ex){
    }

    return new Font(fontName,fontStyle,fontSize);
  }

//--------------------------------------------------------------------//
/**
 * HTML^OŎw肳ꂽlԂ
 * @param name p[^
 * @return HTML^OŎw肳ꂽl
 */
  protected double getTagNumber(String name){
    String value=getParameter(name);
    if(value==null) return Double.NaN;
    try{
      return Double.parseDouble(value);
    }
    catch(NumberFormatException ex){
      return Double.NaN;
    }
  }

//--------------------------------------------------------------------//
/**
 * AvbgԂ
 * @return Avbg܂ޕ
 */
  public String getAppletInfo(){
    return "Applet of 3D Multi Body Dynamics\nAuthor K.Higuchi";
  }

//--------------------------------------------------------------------//
/**
 * ̃Avbg߂p[^Ԃ
 * @return Avbg߂p[^i[z
 */
  public String[][] getParameterInfo(){
    return new String[][]
      {{"data","String","MBD data file name."},
       {"waitTime","double","Animation wait time in millisec."},
       {"fontName","String","Font name. Default is Serif."},
       {"fontStyle","int","Font style. Default is Font.PLAIN."},
       {"fontSize","int","Font size. Default is 14."},
       {"backgroundColor","hexadecimal RGB number",
      	"The color of background."},
       {"foregroundColor","hexadecimal RGB number",
      	"The color of foreground."}};
  }
}
