package mbd;
import figure.Point3D;
import figure.Tuple3D;
import figure.Vector;
import figure.Vector3D;

//--------------------------------------------------------------------//
/**
 * ʒu
 */
public class Position implements Cloneable{

/** dSʒu */
  public Point3D x;

/** x */
  public Vector3D v;

/** x */
  public Vector3D a;

/** IC[p[^ */
  public EulerParameters p;

/** px */
  public Vector3D w;

/** px */
  public Vector3D dw;

/**
 * ʒu\z
 */
  public Position(){
    x=new Point3D();
    v=new Vector3D();
    a=new Vector3D();
    p=new EulerParameters();
    w=new Vector3D();
    dw=new Vector3D();
  }

//--------------------------------------------------------------------//
/**
 * ʒuxNgԂ
 * @param r ̍Ẅʒu
 * @return ʒuxNg
 */
  public Vector vector(Tuple3D r){
    Vector ps=x.toVector();
    ps.add(r.toVector().mul(p.rotateMatrix()));
    return ps;
  }

//--------------------------------------------------------------------//
/**
 * xxNgԂ
 * @param r ̍Ẅʒu
 * @return xxNg
 */
  public Vector velVector(Tuple3D r){
    Vector vl=v.toVector();
    vl.add(-1.0,w.toVector().mul(r.tilde()).mul(p.rotateMatrix()));
    return vl;
  }

//--------------------------------------------------------------------//
/**
 * dSʒuExݒ肷
 * @param rl w_̍̕Wʒu
 * @param xg w_̑S̍Wʒu
 * @param vg w_̑x
 */
  public void setGcPosition(Tuple3D rl,Tuple3D xg,Tuple3D vg){
    Vector xv=xg.toVector();
    xv.add(-1.0,rl.toVector().mul(p.rotateMatrix()));
    x.set(xv.get(0),xv.get(1),xv.get(2));
    Vector vv=vg.toVector();
    vv.add(w.toVector().mul(rl.tilde()).mul(p.rotateMatrix()));
    v.set(vv.get(0),vv.get(1),vv.get(2));
  }

//--------------------------------------------------------------------//
/**
 * ̍WʒuS̍Wɕϊ
 * @param pt Wʒu
 */
  public void trans(Point3D pt){
    Vector ps=x.toVector();
    ps.add(pt.toVector().mul(p.rotateMatrix()));
    pt.set(ps.get(0),ps.get(1),ps.get(2));
  }

//--------------------------------------------------------------------//
/**
 * ̍WʒuS̍Wɕϊ
 * @param pt Wʒui[z
 */
  public void trans(Point3D pt[][]){
    for(int i=0;i<pt.length;i++){
      for(int j=0;j<pt[i].length;j++){
      	trans(pt[i][j]);
      }
    }
  }

//--------------------------------------------------------------------//
/**
 * IC[p[^̕ωʂԂ
 * @return IC[p[^̕ωʂ̂Q{ L \xNg
 */
  public Vector eulerVel(){
    return w.toVector().mul(p.matrixL().transposition());
  }

//--------------------------------------------------------------------//
/**
 * xݒ肷
 * @param av xxNg
 * @param i0 f[^̊JnCfbNX
 */
  protected void setAcc(Vector av,int i0){
    a.set(av.get(i0),av.get(i0+1),av.get(i0+2));
    dw.set(av.get(i0+3),av.get(i0+4),av.get(i0+5));
  }

//--------------------------------------------------------------------//
/**
 * f[^XV
 * @param dx dSʒu̕ω
 * @param dv x̕ω
 * @param dp IC[p[^̕ω
 * @param dw px̕ω
 */
  public void update(Vector3D dx,Vector3D dv,Vector dp,Vector3D dw){
    x.add(dx);
    v.add(dv);
    p.add(dp.get(0),dp.get(1),dp.get(2),dp.get(3));
    w.add(dw);
    p.normalize();
  }

//--------------------------------------------------------------------//
/**
 * f[^XV
 * @param c W
 * @param dx dSʒu̕ω
 * @param dv x̕ω
 * @param dp IC[p[^̕ω
 * @param dw px̕ω
 */
  public void update(double c,Vector3D dx,Vector3D dv,
      	      	     Vector dp,Vector3D dw){
    x.add(c*dx.x,c*dx.y,c*dx.z);
    v.add(c*dv.x,c*dv.y,c*dv.z);
    double ch=0.5*c;
    p.add(ch*dp.get(0),ch*dp.get(1),ch*dp.get(2),ch*dp.get(3));
    w.add(c*dw.x,c*dw.y,c*dw.z);
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̃Rs[Ԃ
 * @return ̃CX^X̕
 */
  public Object clone(){
    try{
      Position pos=(Position)super.clone();
      pos.x=(Point3D)x.clone();
      pos.v=(Vector3D)v.clone();
      pos.a=(Vector3D)a.clone();
      pos.p=(EulerParameters)p.clone();
      pos.w=(Vector3D)w.clone();
      pos.dw=(Vector3D)dw.clone();
      return pos;
    }
    catch(CloneNotSupportedException ex){
      throw new InternalError();
    }
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̃nbVR[hlԂ
 * @return IuWFNg̃nbVR[hl
 */
  public int hashCode(){
    int bit=x.hashCode();
    bit=31*bit+v.hashCode();
    bit=31*bit+a.hashCode();
    bit=31*bit+p.hashCode();
    bit=31*bit+w.hashCode();
    bit=31*bit+dw.hashCode();
    return bit;
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̓
 * @param obj rΏۂ̃IuWFNg
 * @return rΏۂ̃IuWFNg <code>Position</code>
 *         ̃CX^Xœlꍇ true
 */
  public boolean equals(Object obj){
    if(obj instanceof Position){
      Position pos=(Position)obj;
      return (x.equals(pos.x) && v.equals(pos.v) && a.equals(pos.a)
      	   && p.equals(pos.p) && w.equals(pos.w) && dw.equals(pos.dw));
    }
    else{
      return false;
    }
  }
}
