package mbd.body;
import figure.Point3D;
import mbd.Body;

//--------------------------------------------------------------------//
/**
 * pNX
 */
public class Box extends Body{

/** <i>x</i>  */
  public double a;

/** <i>y</i>  */
  public double b;

/** <i>z</i>  */
  public double c;

/** x */
  public double density;

/**
 * ̂\z
 * @param label f[^x
 * @param a <i>x</i> 
 * @param b <i>y</i> 
 * @param c <i>z</i> 
 * @param density x
 */
  public Box(int label,double a,double b,double c,double density){
    super(label);
    this.a=a;
    this.b=b;
    this.c=c;
    this.density=density;
    mass=density*a*b*c;
    double ic=mass/12.0;
    inertia[0][0]=ic*(b*b+c*c);
    inertia[1][1]=ic*(c*c+a*a);
    inertia[2][2]=ic*(a*a+b*b);
  }

//--------------------------------------------------------------------//
/**
 * ̌`\_Ԃ
 * @return _i[z
 */
  public Point3D[][] vertices(){
    double ah=0.5*a;
    double bh=0.5*b;
    double ch=0.5*c;
    Point3D pt[][]={{new Point3D(ah,bh,ch),new Point3D(ah,-bh,ch),
      	      	     new Point3D(-ah,-bh,ch),new Point3D(-ah,bh,ch)},
      	      	    {new Point3D(ah,bh,-ch),new Point3D(ah,-bh,-ch),
      	      	     new Point3D(-ah,-bh,-ch),new Point3D(-ah,bh,-ch)}};
    p.trans(pt);
    return pt;
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̓
 * @param obj rΏۂ̃IuWFNg
 * @return rΏۂ̃IuWFNg <code>Box</code>
 *         ̃CX^Xœlꍇ true
 */
  public boolean equals(Object obj){
    if(super.equals(obj) && (obj instanceof Box)){
      Box box=(Box)obj;
      return ((a==box.a) && (b==box.b) && (c==box.c)
      	   && (density==box.density));
    }
    else{
      return false;
    }
  }

//--------------------------------------------------------------------//
/**
 * f[^Ԃ
 * @return ̃IuWFNg̕\
 */
  public String toString(){
    return "Box\t"+label+"\t"+a+"\t"+b+"\t"+c+"\t"+density;
  }
}
