package mbd.body;
import figure.Point3D;
import mbd.Body;

//--------------------------------------------------------------------//
/**
 * ~NX
 */
public class Cylinder extends Body{

/** Oa */
  public double ro;

/** a */
  public double ri;

/**  */
  public double l;

/** x */
  public double density;

/**
 * ̂\z
 * @param label f[^x
 * @param ro Oa
 * @param ri a
 * @param l 
 * @param density x
 */
  public Cylinder(int label,double ro,double ri,double l,
      	      	  double density){
    super(label);
    this.ro=ro;
    this.ri=ri;
    this.l=l;
    this.density=density;
    mass=Math.PI*density*(ro*ro-ri*ri)*l;
    inertia[0][0]=mass*(3.0*(ro*ro+ri*ri)+l*l)/12.0;
    inertia[1][1]=inertia[0][0];
    inertia[2][2]=0.5*mass*(ro*ro+ri*ri);
  }

//--------------------------------------------------------------------//
/**
 * ̌`\_Ԃ
 * @return _i[z
 */
  public Point3D[][] vertices(){
    int nth=8;
    Point3D pt[][]=new Point3D[4][nth];
    double dth=2.0*Math.PI/(double)nth;
    for(int i=0;i<nth;i++){
      double th=dth*(double)i;
      double x1=ri*Math.cos(th);
      double y1=ri*Math.sin(th);
      double x2=ro*Math.cos(th);
      double y2=ro*Math.sin(th);
      pt[0][i]=new Point3D(x1,y1,0.5*l);
      pt[1][i]=new Point3D(x2,y2,0.5*l);
      pt[2][i]=new Point3D(x2,y2,-0.5*l);
      pt[3][i]=new Point3D(x1,y1,-0.5*l);
    }
    p.trans(pt);
    return pt;
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̓
 * @param obj rΏۂ̃IuWFNg
 * @return rΏۂ̃IuWFNg <code>Cylinder</code>
 *         ̃CX^Xœlꍇ true
 */
  public boolean equals(Object obj){
    if(super.equals(obj) && (obj instanceof Cylinder)){
      Cylinder c=(Cylinder)obj;
      return ((ro==c.ro) && (ri==c.ri) && (l==c.l)
      	   && (density==c.density));
    }
    else{
      return false;
    }
  }

//--------------------------------------------------------------------//
/**
 * f[^Ԃ
 * @return ̃IuWFNg̕\
 */
  public String toString(){
    return "Cylinder\t"+label+"\t"+ro+"\t"+ri+"\t"+l+"\t"+density;
  }
}
