package mbd.constraint;
import figure.DefaultMatrix;
import figure.Matrix;
import figure.Point3D;
import figure.Tuple3D;
import figure.Vector;
import mbd.Constraint;

//--------------------------------------------------------------------//
/**
 * S̒ۃX[p[NX
 */
public abstract class AbstractConstraint implements Constraint{

/** SΏۈʒuP̃CfbNX */
  protected int p1;

/** SΏۈʒuQ̃CfbNX */
  protected int p2;

/** SΏە̂P̍Sʒu */
  protected Point3D r1;

/** SΏە̂Q̍Sʒu */
  protected Point3D r2;

/** S׏dxNg */
  protected Vector vector;

/**
 * S\z
 * @param p1 SΏۈʒuP̃CfbNX
 * @param p2 SΏۈʒuQ̃CfbNX
 * @param r1 SΏە̂P̍Sʒu
 * @param r2 SΏە̂Q̍Sʒu
 */
  protected AbstractConstraint(int p1,int p2,Point3D r1,Point3D r2){
    setPosition(p1,p2);
    setCoords(r1,r2);
  }

//--------------------------------------------------------------------//
/**
 * SΏە̂P̃CfbNXԂ
 * @return SΏە̂P̃CfbNX
 */
  public int p1(){
    return p1;
  }

//--------------------------------------------------------------------//
/**
 * SΏە̂Q̃CfbNXԂ
 * @return SΏە̂Q̃CfbNX
 */
  public int p2(){
    return p2;
  }

//--------------------------------------------------------------------//
/**
 * SΏە̂ݒ肷
 * @param p1 SΏۈʒuP̃CfbNX
 * @param p2 SΏۈʒuQ̃CfbNX
 */
  public void setPosition(int p1,int p2){
    this.p1=p1;
    this.p2=p2;
  }

//--------------------------------------------------------------------//
/**
 * Sʒuݒ肷
 * @param r1 SΏە̂P̍Sʒu
 * @param r2 SΏە̂Q̍Sʒu
 */
  public void setCoords(Point3D r1,Point3D r2){
    this.r1=r1;
    this.r2=r2;
  }

//--------------------------------------------------------------------//
/**
 * SΏە̂PƂQւ
 */
  public void swap(){
    int temp=p1;
    p1=p2;
    p2=temp;
    Point3D tp=r1;
    r1=r2;
    r2=tp;
  }

//--------------------------------------------------------------------//
/**
 * S׏dxNgԂ
 * @return S׏dxNg
 */
  public Vector getVector(){
    return vector;
  }

//--------------------------------------------------------------------//
/**
 * `_}gbNXԂ
 * @param v xNg
 * @return `_}gbNX
 */
  public static Matrix tilde(Vector v){
    Matrix m=new DefaultMatrix(3);
    m.set(0,1,-v.get(2));
    m.set(0,2,v.get(1));
    m.set(1,0,v.get(2));
    m.set(1,2,-v.get(0));
    m.set(2,0,-v.get(1));
    m.set(2,1,v.get(0));
    return m;
  }

//--------------------------------------------------------------------//
/**
 * s̐ςvZ
 * @param m1 sP
 * @param m2 sQ
 * @return s̐
 */
  public static Matrix mul(Matrix m1,Matrix m2){
    return DefaultMatrix.mul(m1,m2);
  }

//--------------------------------------------------------------------//
/**
 * s̐ςvZ
 * @param m1 sP
 * @param m2 sQ
 * @param m3 sR
 * @return s̐
 */
  public static Matrix mul(Matrix m1,Matrix m2,Matrix m3){
    return mul(mul(m1,m2),m3);
  }

//--------------------------------------------------------------------//
/**
 * s̐ςvZ
 * @param m1 sP
 * @param m2 sQ
 * @param m3 sR
 * @param m4 sS
 * @return s̐
 */
  public static Matrix mul(Matrix m1,Matrix m2,Matrix m3,Matrix m4){
    return mul(mul(m1,m2),mul(m3,m4));
  }

//--------------------------------------------------------------------//
/**
 * sƌW̐ςvZ
 * @param c W
 * @param m s
 * @return s̐
 */
  public static Matrix mul(double c,Matrix m){
    m.mul(c);
    return m;
  }

//--------------------------------------------------------------------//
/**
 * sƃxNg̐ςvZ
 * @param m s
 * @param v xNg
 * @return sƃxNg̐
 */
  public static Vector mul(Matrix m,Tuple3D v){
    return mul(m,v.toVector());
  }

//--------------------------------------------------------------------//
/**
 * sƃxNg̐ςvZ
 * @param m s
 * @param v xNg
 * @return sƃxNg̐
 */
  public static Vector mul(Matrix m,Vector v){
    return v.mul(m);
  }

//--------------------------------------------------------------------//
/**
 * sƃxNg̐ςvZ
 * @param m1 sP
 * @param m2 sQ
 * @param v xNg
 * @return sƃxNg̐
 */
  public static Vector mul(Matrix m1,Matrix m2,Tuple3D v){
    return mul(m1,m2,v.toVector());
  }

//--------------------------------------------------------------------//
/**
 * sƃxNg̐ςvZ
 * @param m1 sP
 * @param m2 sQ
 * @param v xNg
 * @return sƃxNg̐
 */
  public static Vector mul(Matrix m1,Matrix m2,Vector v){
    return v.mul(mul(m1,m2));
  }

//--------------------------------------------------------------------//
/**
 * s̘avZ
 * @param m1 sP
 * @param m2 sQ
 * @return s̘a
 */
  public static Matrix add(Matrix m1,Matrix m2){
    m1.add(m2);
    return m1;
  }

//--------------------------------------------------------------------//
/**
 * s̘avZ
 * @param m1 sP
 * @param m2 sQ
 * @param m3 sR
 * @return s̘a
 */
  public static Matrix add(Matrix m1,Matrix m2,Matrix m3){
    m1.add(m2);
    m1.add(m3);
    return m1;
  }

//--------------------------------------------------------------------//
/**
 * s̘avZ
 * @param m1 sP
 * @param m2 sQ
 * @param m3 sR
 * @param m4 sS
 * @return s̘a
 */
  public static Matrix add(Matrix m1,Matrix m2,Matrix m3,Matrix m4){
    m1.add(m2);
    m1.add(m3);
    m1.add(m4);
    return m1;
  }

//--------------------------------------------------------------------//
/**
 * xNg̘avZ
 * @param v1 xNgP
 * @param v2 xNgQ
 * @return xNg̘a
 */
  public static Vector add(Vector v1,Vector v2){
    v1.add(v2);
    return v1;
  }

//--------------------------------------------------------------------//
/**
 * xNg̘avZ
 * @param v1 xNgP
 * @param v2 xNgQ
 * @param v3 xNgR
 * @param v4 xNgS
 * @return xNg̘a
 */
  public static Vector add(Vector v1,Vector v2,Vector v3,Vector v4){
    v1.add(v2);
    v1.add(v3);
    v1.add(v4);
    return v1;
  }

//--------------------------------------------------------------------//
/**
 * xNg̐Ԃ̃XgA
 * @param v xNg
 * @return xNg̐Ԃ̃Xg
 */
  public static int[] compList(Vector v){
    int size=v.size();
    int index[]=new int[size];
    double vv[]=new double[size];
    for(int i=0;i<size;i++){
      index[i]=i;
      vv[i]=Math.abs(v.get(i));
    }
    for(int i=1;i<size;i++){
      double tv=vv[i];
      int ti=index[i];
      if(vv[i-1]>tv){
      	int j=i;
      	do{
      	  vv[j]=vv[j-1];
      	  index[j]=index[j-1];
      	  j--;
      	}while((j>0) && (vv[j-1]>tv));
      	vv[j]=tv;
      	index[j]=ti;
      }
    }
    return index;
  }
}
