package mbd.constraint;
import figure.DefaultMatrix;
import figure.Matrix;
import figure.Point3D;
import figure.Vector;
import figure.Vector3D;
import mbd.Position;
import mbd.RigidConstraint;

//--------------------------------------------------------------------//
/**
 * S̒ۃX[p[NX
 */
public abstract class AbstractRigidConstraint
  extends AbstractConstraint implements RigidConstraint{

/** oEKë艻p[^ */
  protected double alpha;

/** oEKë艻p[^ */
  protected double beta;

/** S}gbNX */
  protected Matrix matrix[];

/**
 * S\z
 * @param p1 SΏۈʒuP̃CfbNX
 * @param p2 SΏۈʒuQ̃CfbNX
 * @param r1 SΏە̂P̍Sʒu
 * @param r2 SΏە̂Q̍Sʒu
 */
  protected AbstractRigidConstraint(int p1,int p2,Point3D r1,
      	      	      	      	    Point3D r2){
    super(p1,p2,r1,r2);
    alpha=10.0;
    beta=10.0;
    matrix=new Matrix[2];
  }

//--------------------------------------------------------------------//
/**
 * oEKë艻p[^ݒ肷
 * @param alpha oEKë艻p[^
 * @param beta oEKë艻p[^
 */
  public void setBaumgarte(double alpha,double beta){
    this.alpha=alpha;
    this.beta=beta;
  }

//--------------------------------------------------------------------//
/**
 * S}gbNXԂ
 * @return S}gbNX
 */
  public Matrix[] getMatrix(){
    return matrix;
  }

//--------------------------------------------------------------------//
/**
 * _S}gbNXES׏dxNg쐬
 * @param p1 SΏۈʒuP
 * @param p2 SΏۈʒuQ
 * @param index S̊Jns
 */
  public void point(Position p1,Position p2,int index){
    Vector g1=point(p1,r1,index,0);
    if(g1!=null){
      vector.add(index,-g1.get(0));
      vector.add(index+1,-g1.get(1));
      vector.add(index+2,-g1.get(2));
    }
    Vector g2=point(p2,r2,index,1);
    if(g2!=null){
      vector.add(index,g2.get(0));
      vector.add(index+1,g2.get(1));
      vector.add(index+2,g2.get(2));
    }
  }

//--------------------------------------------------------------------//
/**
 * S}gbNXES׏dxNg쐬
 * @param p SΏۈʒu
 * @param r Sʒu
 * @param index S̊Jns
 * @param mi ̂̃CfbNX
 * @return S׏dxNg
 */
  protected Vector point(Position p,Point3D r,int index,int mi){
    if((p==null) || (r==null)) return null;
    Matrix rot=p.p.rotateMatrix();
    Matrix rtl=r.tilde();
    Matrix cth=mul(-1.0,mul(rot,rtl));
    double cf=(double)(2*mi)-1.0;
    for(int i=0;i<3;i++){
      matrix[mi].set(index+i,i,cf);
      for(int j=0;j<3;j++){
      	matrix[mi].set(index+i,j+3,cf*cth.get(i,j));
      }
    }
    Vector w=p.w.toVector();
    Vector gam=mul(mul(rot,tilde(w),rtl),w);
    gam.add(-2.0*alpha,add(p.v.toVector(),mul(cth,w)));
    gam.add(-beta*beta,p.vector(r));
    return gam;
  }

//--------------------------------------------------------------------//
/**
 * S}gbNXES׏dxNg쐬
 * @param p1 SΏۈʒuP
 * @param p2 SΏۈʒuQ
 * @param s1 SΏە̂P̈ړ
 * @param s2 SΏە̂Q̈ړ
 * @param index S̊Jns
 */
  public void axis(Position p1,Position p2,Vector3D s1,Vector3D s2,
      	      	   int index){
    Matrix rot1=p1.p.rotateMatrix();
    Matrix rot2=p2.p.rotateMatrix();
    Matrix stl1=s1.tilde();
    Matrix stl2=s2.tilde();
    Matrix wtl1=p1.w.tilde();
    Matrix wtl2=p2.w.tilde();
    Matrix rotstl1=mul(rot1,stl1);
    Matrix rotstl2=mul(rot2,stl2);
    Matrix a12=mul(rot1.transposition(),rot2);
    Matrix a21=mul(rot2.transposition(),rot1);

    Matrix cth[]={mul(rotstl2,rot2.transposition(),rot1,stl1),
      	      	  mul(-1.0,mul(rotstl1,rot1.transposition(),rotstl2))};
    Matrix a1=add(mul(tilde(mul(wtl2,s2)),a21),mul(stl2,a21,wtl1));
    a1=mul(-1.0,mul(rot2,a1,stl1));
    Matrix a2=add(mul(tilde(mul(wtl1,s1)),a12),mul(stl1,a12,wtl2));
    a2=mul(rot1,a1,stl2);
    Vector gam=add(mul(a1,p1.w),mul(a2,p2.w));
    gam.add(-2.0*alpha,add(mul(cth[0],p1.w),mul(cth[1],p2.w)));
    gam.add(-beta*beta,mul(rotstl1,a12,s2));

    int cl[]=compList(mul(rot1,s1));
    for(int i=0;i<2;i++){
      for(int j=0;j<3;j++){
      	matrix[0].set(index+i,j+3,cth[0].get(cl[i],j));
      	matrix[1].set(index+i,j+3,cth[1].get(cl[i],j));
      }
      vector.set(index+i,gam.get(cl[i]));
    }
  }

//--------------------------------------------------------------------//
/**
 * ΈʒuS}gbNXES׏dxNg쐬
 * @param p1 SΏۈʒuP
 * @param p2 SΏۈʒuQ
 * @param s SΏە̂P̈ړ
 * @param index S̊Jns
 */
  public void direction(Position p1,Position p2,Vector3D s,
      	      	      	int index){
    Matrix rot1=p1.p.rotateMatrix();
    Matrix rot2=p2.p.rotateMatrix();
    Matrix stl=s.tilde();
    Matrix rtl1=r1.tilde();
    Matrix rtl2=r2.tilde();
    Matrix wtl1=p1.w.tilde();
    Matrix wtl2=p2.w.tilde();
    Matrix rotstl=mul(rot1,stl);
    Matrix rtr=mul(rotstl,rot1.transposition());

    Vector d12=p2.vector(r2);
    d12.add(-1.0,p1.vector(r1));
    Matrix cr[]={mul(-1.0,(Matrix)rtr.clone()),rtr};
    Matrix cth[]={add(mul(rtr,rot1,rtl1),mul(tilde(d12),rotstl)),
      	      	  mul(-1.0,mul(rtr,rot2,rtl2))};
    Matrix a2=mul(rot1,wtl1);
    Matrix a1=mul(2.0,add(p1.v.tilde(),mul(-1.0,p2.v.tilde())));
    Vector gam=mul(a1,rotstl,p1.w);
    Vector v1=mul(rot2,wtl2,r2);
    v1.add(-1.0,mul(a2,r1));
    a1=mul(-1.0,add(mul(a2,stl,rtl1),mul(tilde(v1),rotstl),
      	      	    mul(tilde(d12),a2,stl)));
    a2=mul(rot1.transposition(),rot2);
    a2=mul(add(mul(rot1,tilde(mul(wtl1,s)),a2),
      	       mul(rtr,rot2,wtl2)),rtl2);
    gam.add(add(mul(a1,p1.w),mul(a2,p2.w)));
    gam.add(-2.0*alpha,add(mul(cr[0],p1.v),mul(cr[1],p2.v),
      	      	      	   mul(cth[0],p1.w),mul(cth[1],p2.w)));
    gam.add(-beta*beta,mul(rtr,d12));

    int cl[]=compList(mul(rot1,s));
    for(int i=0;i<2;i++){
      for(int j=0;j<3;j++){
      	matrix[0].set(index+i,j,cr[0].get(cl[i],j));
      	matrix[0].set(index+i,j+3,cth[0].get(cl[i],j));
      	matrix[1].set(index+i,j,cr[1].get(cl[i],j));
      	matrix[1].set(index+i,j+3,cth[1].get(cl[i],j));
      }
      vector.set(index+i,gam.get(cl[i]));
    }
  }

//--------------------------------------------------------------------//
/**
 * ]S}gbNXES׏dxNg쐬
 * @param p1 SΏۈʒuP
 * @param p2 SΏۈʒuQ
 * @param b1x SΏە̂P̈ړ
 * @param b2y SΏە̂Q̈ړ
 * @param index S̊Jns
 */
  public void rotate(Position p1,Position p2,Vector3D b1x,Vector3D b2y,
      	      	     int index){
    Matrix rot1=p1.p.rotateMatrix();
    Matrix rot2=p2.p.rotateMatrix();
    Matrix wtl1=p1.w.tilde();
    Matrix wtl2=p2.w.tilde();
    Matrix a12=mul(rot1.transposition(),rot2);
    Matrix a21=mul(rot2.transposition(),rot1);

    Matrix cth[]={new DefaultMatrix(1,3),new DefaultMatrix(1,3)};
    cth[0].set(0,0,-b2y.x);
    cth[0].set(0,1,-b2y.y);
    cth[0].set(0,2,-b2y.z);
    cth[0]=mul(cth[0],a21,b1x.tilde());
    cth[1].set(0,0,-b1x.x);
    cth[1].set(0,1,-b1x.y);
    cth[1].set(0,2,-b1x.z);
    cth[1]=mul(cth[1],a12,b2y.tilde());
    Matrix a1=add(mul(a21,wtl1,wtl1),mul(wtl2,wtl2,a21));
    Matrix a2=mul(b2y.tilde(),a21,b1x.tilde());
    Vector v1=mul(a1,b1x);
    double gam1=b2y.x*v1.get(0)+b2y.y*v1.get(1)+b2y.z*v1.get(2);
    v1=mul(a2,p1.w);
    double gam2=p2.w.x*v1.get(0)+p2.w.y*v1.get(1)+p2.w.z*v1.get(2);
    v1=add(mul(cth[0],p1.w),mul(cth[1],p2.w));
    double gam3=v1.get(0);
    v1=mul(a12,b2y);
    double gam4=b1x.x*v1.get(0)+b1x.y*v1.get(1)+b1x.z*v1.get(2);
    double gam=-gam1+2.0*gam2-2.0*alpha*gam3-beta*beta*gam4;
    for(int j=0;j<3;j++){
      matrix[0].set(index,j+3,cth[0].get(0,j));
      matrix[1].set(index,j+3,cth[1].get(0,j));
    }
    vector.set(index,gam);
  }
}
