package mbd.constraint;
import figure.DefaultMatrix;
import figure.Point3D;
import figure.Vector;
import figure.Vector3D;
import mbd.Position;

//--------------------------------------------------------------------//
/**
 * WCg
 */
public class BallJoint extends AbstractRigidConstraint{

/** S鎩Rx */
  public static final int DOF=3;

/**
 * WCg\z
 * @param p1 SΏۈʒuP̃CfbNX
 * @param p2 SΏۈʒuQ̃CfbNX
 * @param r1 SΏە̂P̍Sʒu
 * @param r2 SΏە̂Q̍Sʒu
 */
  public BallJoint(int p1,int p2,Point3D r1,Point3D r2){
    super(p1,p2,r1,r2);
    vector=new Vector(DOF);
  }

//--------------------------------------------------------------------//
/**
 * S鎩RxԂ
 * @return S鎩Rx
 */
  public int dof(){
    return DOF;
  }

//--------------------------------------------------------------------//
/**
 * dSʒuExݒ肷
 * @param p1 SΏۈʒuP
 * @param p2 SΏۈʒuQ
 */
  public void setGcPosition(Position p1,Position p2){
    if(p1==null){
      p2.setGcPosition(r2,r1,new Vector3D());
    }
    else{
      Vector x=p1.vector(r1);
      Vector v=p1.velVector(r1);
      p2.setGcPosition(r2,new Vector3D(x.get(0),x.get(1),x.get(2)),
      	      	       new Vector3D(v.get(0),v.get(1),v.get(2)));
    }
  }

//--------------------------------------------------------------------//
/**
 * S}gbNXES׏dxNg쐬
 * @param p1 SΏۈʒuP
 * @param p2 SΏۈʒuQ
 */
  public void create(Position p1,Position p2){
    vector.clear();
    if(p1!=null) matrix[0]=new DefaultMatrix(DOF,6);
    if(p2!=null) matrix[1]=new DefaultMatrix(DOF,6);
    point(p1,p2,0);
  }

//--------------------------------------------------------------------//
/**
 * f[^Ԃ
 * @return ̃IuWFNg̕\
 */
  public String toString(){
    return "BallJoint\t"+p1+"\t"+p2+"\t"+r1.x+"\t"+r1.y+"\t"+r1.z
      	  +"\t"+r2.x+"\t"+r2.y+"\t"+r2.z;
  }
}
