package mbd.constraint;
import figure.DefaultMatrix;
import figure.Point3D;
import figure.Vector;
import figure.Vector3D;
import mbd.Position;

//--------------------------------------------------------------------//
/**
 * ]iWCg
 */
public class Slider extends AbstractRigidConstraint{

/** S鎩Rx */
  public static final int DOF=5;

/** SΏە̂P̈ړ */
  protected Vector3D s1;

/** SΏە̂Q̈ړ */
  protected Vector3D s2;

/** SΏە̂P̈ړ */
  protected Vector3D b1x;

/** SΏە̂Q̈ړ */
  protected Vector3D b2x;

/** ʒu */
  protected double z0;

/**
 * ]iWCg\z
 * @param p1 SΏۈʒuP̃CfbNX
 * @param p2 SΏۈʒuQ̃CfbNX
 * @param r1 SΏە̂P̍Sʒu
 * @param r2 SΏە̂Q̍Sʒu
 * @param z0 ʒu
 */
  public Slider(int p1,int p2,Point3D r1,Point3D r2,double z0){
    super(p1,p2,r1,r2);
    this.z0=z0;
    vector=new Vector(DOF);
    s1=new Vector3D(0.0,0.0,1.0);
    s2=new Vector3D(0.0,0.0,1.0);
    b1x=new Vector3D(1.0,0.0,0.0);
    b2x=new Vector3D(1.0,0.0,0.0);
    matrix[0]=new DefaultMatrix(DOF,6);
    matrix[1]=new DefaultMatrix(DOF,6);
  }

//--------------------------------------------------------------------//
/**
 * S鎩RxԂ
 * @return S鎩Rx
 */
  public int dof(){
    return DOF;
  }

//--------------------------------------------------------------------//
/**
 * SΏە̂̎ݒ肷
 * @param s1 SΏە̂P̈ړ
 * @param s2 SΏە̂Q̈ړ
 * @param b1x SΏە̂P̈ړ
 * @param b2x SΏە̂Q̈ړ
 */
  public void setAxis(Vector3D s1,Vector3D s2,
      	      	      Vector3D b1x,Vector3D b2x){
    this.s1=s1;
    this.s2=s2;
    this.b1x=b1x;
    this.b2x=b2x;
  }

//--------------------------------------------------------------------//
/**
 * dSʒuExݒ肷
 * @param p1 SΏۈʒuP
 * @param p2 SΏۈʒuQ
 */
  public void setGcPosition(Position p1,Position p2){
    Vector3D ri=new Vector3D(r1.x+z0*s1.x,r1.y+z0*s1.y,r1.z+z0*s1.z);
    Vector x=p1.vector(ri);
    Vector v=p1.velVector(ri);
    p2.setGcPosition(r2,new Vector3D(x.get(0),x.get(1),x.get(2)),
      	      	     new Vector3D(v.get(0),v.get(1),v.get(2)));
  }

//--------------------------------------------------------------------//
/**
 * S}gbNXES׏dxNg쐬
 * @param p1 SΏۈʒuP
 * @param p2 SΏۈʒuQ
 */
  public void create(Position p1,Position p2){
    Vector3D b2y=s2.crossProduct(b2x);
    b2y.normalize();
    axis(p1,p2,s1,s2,0);
    direction(p1,p2,s1,2);
    rotate(p1,p2,b1x,b2y,4);
  }

//--------------------------------------------------------------------//
/**
 * f[^Ԃ
 * @return ̃IuWFNg̕\
 */
  public String toString(){
    return "Slider\t"+p1+"\t"+p2+"\t"+r1.x+"\t"+r1.y+"\t"+r1.z
      	  +"\t"+r2.x+"\t"+r2.y+"\t"+r2.z+"\t"+z0;
  }
}
