package mbd.constraint;
import figure.DefaultMatrix;
import figure.Point3D;
import figure.Vector;
import figure.Vector3D;
import mbd.Position;

//--------------------------------------------------------------------//
/**
 * jo[TWCg
 */
public class UniversalJoint extends AbstractRigidConstraint{

/** S鎩Rx */
  public static final int DOF=4;

/** SΏە̂P̉] */
  protected Vector3D b1x;

/** SΏە̂Q̉] */
  protected Vector3D b2y;

/**
 * jo[TWCg\z
 * @param p1 SΏۈʒuP̃CfbNX
 * @param p2 SΏۈʒuQ̃CfbNX
 * @param r1 SΏە̂P̍Sʒu
 * @param r2 SΏە̂Q̍Sʒu
 */
  public UniversalJoint(int p1,int p2,Point3D r1,Point3D r2){
    super(p1,p2,r1,r2);
    vector=new Vector(DOF);
    b1x=new Vector3D(1.0,0.0,0.0);
    b2y=new Vector3D(0.0,1.0,0.0);
    matrix[0]=new DefaultMatrix(DOF,6);
    matrix[1]=new DefaultMatrix(DOF,6);
  }

//--------------------------------------------------------------------//
/**
 * S鎩RxԂ
 * @return S鎩Rx
 */
  public int dof(){
    return DOF;
  }

//--------------------------------------------------------------------//
/**
 * SΏە̂̎ݒ肷
 * @param b1x SΏە̂P̉]
 * @param b2y SΏە̂Q̉]
 */
  public void setAxis(Vector3D b1x,Vector3D b2y){
    this.b1x=b1x;
    this.b2y=b2y;
  }

//--------------------------------------------------------------------//
/**
 * dSʒuExݒ肷
 * @param p1 SΏۈʒuP
 * @param p2 SΏۈʒuQ
 */
  public void setGcPosition(Position p1,Position p2){
    Vector x=p1.vector(r1);
    Vector v=p1.velVector(r1);
    p2.setGcPosition(r2,new Vector3D(x.get(0),x.get(1),x.get(2)),
      	      	     new Vector3D(v.get(0),v.get(1),v.get(2)));
  }

//--------------------------------------------------------------------//
/**
 * S}gbNXES׏dxNg쐬
 * @param p1 SΏۈʒuP
 * @param p2 SΏۈʒuQ
 */
  public void create(Position p1,Position p2){
    vector.clear();
    point(p1,p2,0);
    rotate(p1,p2,b1x,b2y,3);
  }

//--------------------------------------------------------------------//
/**
 * f[^Ԃ
 * @return ̃IuWFNg̕\
 */
  public String toString(){
    return "UniversalJoint\t"+p1+"\t"+p2+"\t"+r1.x+"\t"+r1.y+"\t"+r1.z
      	  +"\t"+r2.x+"\t"+r2.y+"\t"+r2.z;
  }
}
