package resourcemanager;
import java.io.InputStream;
import java.io.IOException;
import java.net.URL;
import java.util.HashMap;
import java.util.Map;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;
import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;

//--------------------------------------------------------------------//
/**
 * XML ̃f[^ǗNX
 */
public class XMLDataMap{

/** f[^i[}bv */
  private Map<String,String> map;

/**
 * XML ̃f[^ǗIuWFNg\z
 */
  public XMLDataMap(){
    map=new HashMap<String,String>();
  }

//--------------------------------------------------------------------//
/**
 * URL  XML ǂݍ
 * @param url f[^ URL
 * @throws ParserConfigurationException
 *         vꂽ\𖞂 <code>DocumentBuilder</code>
 *         𐶐łȂƂ
 * @throws SAXException \̓G[Ƃ
 * @throws IOException o̓G[Ƃ
 */
  public void readFromURL(URL url)
    throws ParserConfigurationException,SAXException,IOException{
    readFromStream(url.openStream());
  }

//--------------------------------------------------------------------//
/**
 * ̓Xg[ XML ǂݍ
 * @param is ̓Xg[
 * @throws ParserConfigurationException
 *         vꂽ\𖞂 <code>DocumentBuilder</code>
 *         𐶐łȂƂ
 * @throws SAXException \̓G[Ƃ
 * @throws IOException o̓G[Ƃ
 */
  public void readFromStream(InputStream is)
    throws ParserConfigurationException,SAXException,IOException{

    SAXParserFactory factory=SAXParserFactory.newInstance();
    SAXParser parser=factory.newSAXParser();
    parser.parse(is,new DataReadHandler());
  }

//--------------------------------------------------------------------//
/**
 * f[^Ԃ
 * @param key f[^̃L[
 * @return f[^̒l
 */
  public String getName(String key){
    return (String)map.get(key);
  }

//--------------------------------------------------------------------//
/**
 * f[^ǂݍ SAX Cxgnh[
 */
  protected class DataReadHandler extends DefaultHandler{

/** f[^L[ */
    protected String key;

    public DataReadHandler(){
      super();
      key=null;
    }

//--------------------------------------------------------------------//
/**
 * vf̐擪ǂݍ
 * @param uri O URI
 * @param localName ړ܂܂Ȃ[J
 * @param qName ړC
 * @param attributes vfɕtꂽ
 * @throws SAXException \̓G[Ƃ
 */
    public void startElement(String uri,String localName,String qName,
      	      	      	     Attributes attributes)
      throws SAXException{

      if(attributes==null){
      	key=qName;
      }
      else{
      	for(int i=0;i<attributes.getLength();i++){
      	  if(attributes.getQName(i).toLowerCase().equals("name")){
      	    key=attributes.getValue(i);
      	  }
      	}
      }
    }

//--------------------------------------------------------------------//
/**
 * f[^ǂݍ
 * @param ch f[^
 * @param start z̊Jnʒu
 * @param length z񂩂gp镶
 * @throws SAXException \̓G[Ƃ
 */
    public void characters(char[] ch,int start,int length)
      throws SAXException{

      if(key==null) return;
      String value=new String(ch,start,length).trim();
      if(!value.equals("")){
      	map.put(key,value);
      }
    }

//--------------------------------------------------------------------//
/**
 * vf̖[̒ʒm󂯎
 * @param uri O URI
 * @param localName ړ܂܂Ȃ[J
 * @param qName ړC
 * @throws SAXException \̓G[Ƃ
 */
    public void endElement(String uri,String localName,String qName)
      throws SAXException{

      key=null;
    }
  }
}
